#define FILECODEINT 11111

#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/ioctl.h>

#include "memmgmt.h"
#include "iocontrols.h"

int main(void) {
	unsigned int ver;
	int vmmon = 0;
	unsigned int r;
	unsigned char bzuma[16384];
	VMGetMemInfoArgs *vmg;
	int difference = 0;
	
	ver = ioctl(vmmon, IOCTLCMD_VERSION, 0);
	if ((int)ver == -1) {
		difference = 1800;
		ver = ioctl(vmmon, IOCTLCMD_VERSION + difference, 0);
		if ((int)ver == -1) {
			fprintf(stderr, "stdin is not /dev/vmmon\n");
			return 44;
		}
	}
	printf("Version: %u.%05u\n", ver / 65536, ver % 65536);
	errno = 0;
	r = ioctl(vmmon, IOCTLCMD_CREATE_VM + difference, 0);
	printf("Create VM: %08X (%s)\n", r, strerror(errno));
	memset(bzuma, 0, sizeof(bzuma));
	vmg = (void*)bzuma;
	vmg->numVMs = 40;
	r = ioctl(vmmon, IOCTLCMD_GET_MEM_INFO + difference, vmg);
	printf("Get Memory Info: %u\n", r);
	printf("  Num VMs:          %d\n", vmg->numVMs);
	printf("  Num Locked Pages: %d\n", vmg->numLockedPages);
	printf("  Max Locked Pages: %d\n", vmg->maxLockedPages);
	printf("  Curr VM Index:    %d\n", vmg->callerIndex);
	for (r = 0; r < vmg->numVMs; r++) {
		VMMemMgmtInfo* v = vmg->memMgmtInfo + r;
		printf("VM #%u\n", r);
		printf("  Page Fault Rate: %d\n", v->pageFaultRate);
		printf("  Lock Fail Rate:  %d\n", v->lockFailRate);
		printf("  Max Locked:      %d\n", v->maxLocked);
		printf("  Current Locked:  %d\n", v->currentLocked);
		printf("  High Water Mark: %d\n", v->highWaterMark);
		printf("  Waiting For Mem: %d\n", v->waitingForMemoryTime);
		printf("  Powering On:     %d\n", v->poweringOn);
		printf("  Has Focus:       %d\n", v->hasFocus);
	}
	return 0;
}

